--[[

Name: FuBar_VampwatchFu
Revision: $Revision: 33585 $
Date: $Date: 2007-04-24 03:06:46 -0400 (Tue, 24 Apr 2007) $
Author(s): jayrox (jayrox@gmail.com)
Description: Stats for Vampiric Touch, Vampiric Embrace and Shadowfied for Priests.
Dependencies: Ace2

]]--

VampwatchFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceEvent-2.0", "CandyBar-2.0") --, "AceDebug-2.0")
local parser = ParserLib:GetInstance("1.1")
local tablet = AceLibrary("Tablet-2.0")
local L = AceLibrary("AceLocale-2.2"):new("FuBar_VampwatchFu")
local crayon = AceLibrary("Crayon-2.0")
local bs = AceLibrary("Babble-Spell-2.2")

StaticPopupDialogs["VampwatchFUCONFIRM"] = { }

VampwatchFu:RegisterDB("VampwatchFuDB")
VampwatchFu:RegisterDefaults('char', {
	useConfirm = true,
	useTimer = true,
	useVT = true,
	useVE = true,
	useSF = true,
	useML = true,
	useLast = true,
	useTotal = false,
	filterOverheal = false,
	SpamOnClick = true,
	useTitle = true,
	channel = L["say"],
	barposition = {},

	vtTotal = 0,
	vtLast = 0,
	vtTicks = 0,
	vtAvg = 0,
	vtHigh = 0,
	vtTTotal = 0,
	
	veTotal = 0,
	veLast = 0,
	veTicks = 0,
	veAvg = 0,
	veHigh = 0,
	veTTotal = 0,

	sfTotal = 0,
	sfLast = 0,
	sfTicks = 0,
	sfAvg = 0,
	sfHigh = 0,
	sfTTotal = 0,
})

VampwatchFu.hasIcon = "Interface\\Icons\\Spell_Shadow_ImprovedVampiricEmbrace"
VampwatchFu.hideMenuTitle = false
VampwatchFu.hasNoColor = false
VampwatchFu.hasNoText = false
VampwatchFu.clickableTooltip = true
VampwatchFu.defaultPosition = "CENTER"
VampwatchFu.Debugging = false
VampwatchFu.DebugLevel = 1

--- ========================================================= ---
--- Revision
--- ========================================================= ---
local Revision = tonumber(string.sub("$Revision: 33585 $", 12, -3))
VampwatchFu.Version = "1.0"
if Revision then
	VampwatchFu.Version = VampwatchFu.Version .. " Rev." .. Revision
end

VampwatchFu.events = {
	['CHAT_MSG_SPELL_PET_BUFF'] = true,
	['CHAT_MSG_SPELL_SELF_BUFF'] = true,
}

VampwatchFu.menuOptions = {
	type = 'group',
	args = {
		header = {
			type = "header",
			name = L["addonname"] .. " V." .. VampwatchFu.Version,
			icon = VampwatchFu.hasIcon,
			iconHeight = 16,
			iconWidth = 16,
			order = 100
		},
		headerspacer101 = {
			type = "header",
			name = " ",
			order = 101
		},
		showtitle = {
			type = "toggle",
			name = L["show_title"],
			desc = L["show_title_desc"],
			get = function() return VampwatchFu.db.char.useTitle end,
			set = function() VampwatchFu.db.char.useTitle = not VampwatchFu.db.char.useTitle VampwatchFu:UpdateText() end,
			order = 200
		},
		ve = {
			type = "toggle",
			name = L["vamp_embrace"],
			desc = L["vamp_embrace_desc"],
			get = function() return VampwatchFu.db.char.useVE end,
			set = function() VampwatchFu.db.char.useVE = not VampwatchFu.db.char.useVE VampwatchFu:UpdateText() end,
			order = 201
		},
		vt = {
			type = "toggle",
			name = L["vamp_touch"],
			desc = L["vamp_touch_desc"],
			get = function() return VampwatchFu.db.char.useVT end,
			set = function() VampwatchFu.db.char.useVT = not VampwatchFu.db.char.useVT VampwatchFu:UpdateText() end,
			order = 202
		},
		sftoggle = {
			type = "toggle",
			name = L["sf_toggle"],
			desc = L["sf_toggle_desc"],
			get = function() return VampwatchFu.db.char.useSF end,
			set = function() VampwatchFu.db.char.useSF = not VampwatchFu.db.char.useSF VampwatchFu:UpdateText() end,
			order = 203
		},
		titletext = {
			type = "group",
			name = L["title_text"],
			desc = L["title_text_desc"],
			disabled = function() return not FuBar end,
			args = {
				titlelast = {
					type = "toggle",
					name = L["title_last"],
					desc = L["title_last"],
					get = function() return VampwatchFu.db.char.useLast end,
					set = function(v)
						VampwatchFu.db.char.useLast = true
						VampwatchFu.db.char.useTotal = false
 						VampwatchFu:UpdateText()
					end,
					order = 1,
				},
				titletotal = {
					type = "toggle",
					name = L["title_total"],
					desc = L["title_total"],
					get = function() return VampwatchFu.db.char.useTotal end,
					set = function(v)
						VampwatchFu.db.char.useLast = false
						VampwatchFu.db.char.useTotal = true
 						VampwatchFu:UpdateText()
					end,
					order = 2,
				},
			},
			order = 204,
		},
		headerspacer300 = {
			type = "header",
			name = " ",
			order = 300
		},
		filteroverheal = {
			type = "toggle",
			name = L["filteroverheal"],
			desc = L["filteroverheal_desc"],
			get = function() return VampwatchFu.db.char.filterOverheal end,
			set = function() VampwatchFu.db.char.filterOverheal = not VampwatchFu.db.char.filterOverheal VampwatchFu:UpdateText() end,
			order = 301
		},
		headerspacer400 = {
			type = "header",
			name = " ",
			order = 400
		},
		shadowfiendtimer = {
			type = "toggle",
			name = L["sf_timer"],
			desc = L["sf_timer_desc"],
			get = function() return VampwatchFu.db.char.useTimer end,
			set = function() VampwatchFu.db.char.useTimer = not VampwatchFu.db.char.useTimer VampwatchFu:UpdateText() end,
			order = 401
		},
		anchor = {
			name = L["Show Anchor"],
			desc = L["Shows the dragable anchor."],
			type = "execute",
			func = "ToggleAnchor",
			order = 402
		},
		headerspacer500 = {
			type = "header",
			name = " ",
			order = 500
		},
		multiline = {
			type = "toggle",
			name = L["multiline"],
			desc = L["multiline"],
			get = function() return VampwatchFu.db.char.useML end,
			set = function() VampwatchFu.db.char.useML = not VampwatchFu.db.char.useML VampwatchFu:UpdateText() end,
			order = 501
		},
		spamonclick = {
			type = "toggle",
			name = L["spam_on_click"],
			desc = L["spam_on_click_desc"],
			get = function() return VampwatchFu.db.char.SpamOnClick end,
			set = function() VampwatchFu.db.char.SpamOnClick = not VampwatchFu.db.char.SpamOnClick VampwatchFu:UpdateText() end,
			order = 502
		},
		sendto = {
			type = 'text',
			name = L["broadcast_opt"],
			desc = L["broadcast_opt"],
			usage = '<'.. L["broadcast_opt"].. '>',
			get = function()
				return VampwatchFu.db.char.channel
			end,
			set = function(v)
				VampwatchFu.db.char.channel = v;
			end,
			validate = {L["say"],L["party"],L["raid"],L["guild"]},
			order = 503
		},
		headerspacer600 = {
			type = "header",
			name = " ",
			order = 600
		},
		resettotals = {
			type = "execute",
			name = L["reset_totals"],
			desc = L["reset_totals_desc"],
			func = function() 
				VampwatchFu:Confirm(L["Reset_confirm_totals"], function() VampwatchFu:ResetTStats() VampwatchFu:UpdateText() end)
			end,
			order = 601
		},
		resetall = {
			type = "execute",
			name = L["reset_all"],
			desc = L["reset_all_desc"],
			func = function() 
				VampwatchFu:Confirm(L["Reset_confirm"], function() VampwatchFu:ResetStats() VampwatchFu:UpdateText() end)
			end,
			order = 602
		},
	},
}

function VampwatchFu:ResetStats()
	VampwatchFu.db.char.vtLast = 0 
	VampwatchFu.db.char.vtHigh = 0 
	VampwatchFu.db.char.vtAvg = 0 
	VampwatchFu.db.char.vtTicks = 0 
	VampwatchFu.db.char.vtTotal = 0
	VampwatchFu.db.char.vtTTotal = 0
	
	VampwatchFu.db.char.veTotal = 0
	VampwatchFu.db.char.veTicks = 0
	VampwatchFu.db.char.veAvg = 0
	VampwatchFu.db.char.veHigh = 0
	VampwatchFu.db.char.veLast = 0
	VampwatchFu.db.char.veTTotal = 0
	
	VampwatchFu.db.char.sfTicks = 0
	VampwatchFu.db.char.sfAvg = 0
	VampwatchFu.db.char.sfHigh = 0
	VampwatchFu.db.char.sfTotal = 0
	VampwatchFu.db.char.sfLast = 0
	VampwatchFu.db.char.sfTTotal = 0
end

function VampwatchFu:ResetTStats()
	VampwatchFu.db.char.vtTotal = 0 
	VampwatchFu.db.char.vtLast = 0 

	VampwatchFu.db.char.sfTotal = 0
	VampwatchFu.db.char.sfLast = 0

	VampwatchFu.db.char.veTotal = 0
	VampwatchFu.db.char.veLast = 0
end

function VampwatchFu:OnTextUpdate()
	local msg = "";
	if(VampwatchFu.db.char.useTitle ~=nil and VampwatchFu.db.char.useTitle == true) then
		msg = msg .. crayon:Red(L["VampwatchFu"]);
	end
	if(VampwatchFu.db.char.useLast == true) then
		tvt = VampwatchFu.db.char.vtLast
		tve = VampwatchFu.db.char.veLast
		tsf = VampwatchFu.db.char.sfLast
	elseif(VampwatchFu.db.char.useTotal == true) then
		tvt = VampwatchFu.db.char.vtTotal
		tve = VampwatchFu.db.char.veTotal
		tsf = VampwatchFu.db.char.sfTotal
	end
	if(VampwatchFu.db.char.useVT ~=nil and VampwatchFu.db.char.useVT == true) then
		msg = msg .. crayon:Purple(L["vt_title"]) .. crayon:Red(tvt);
	end
	if(VampwatchFu.db.char.useVE ~= nil and VampwatchFu.db.char.useVE == true) then
		msg = msg .. crayon:Purple(L["ve_title"]) .. crayon:Red(tve);
	end
	if(VampwatchFu.db.char.useSF ~= nil and VampwatchFu.db.char.useSF == true) then
		msg = msg .. crayon:Purple(L["sf_title"]) .. crayon:Red(tsf);
	end
	self:SetText(msg)
end


function VampwatchFu:PLAYER_REGEN_DISABLED()		
	VampwatchFu.db.char.veLast = 0;
	VampwatchFu.db.char.vtLast = 0;
	VampwatchFu.db.char.sfLast = 0;
end

function VampwatchFu:UNIT_SPELLCAST_SENT(player, spell, rank, target)
	if (spell == bs["Shadowfiend"] and VampwatchFu.db.char.useTimer == true) then
		self:StartCandyBar("VampwatchFuSF", false)
	end
end

function VampwatchFu:OnInitialize()
	self:RegisterChatCommand(L["consolecommands"], self.OnMenuRequest)
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("UNIT_SPELLCAST_SENT");
	for event in pairs(self.events) do
		if not parser:IsEventRegistered("VampwatchFu", event) then
			parser:RegisterEvent("VampwatchFu", event, function(event, info) self:OnCombatEvent(event, info) end)
		end
	end
	self.anchor = self:CreateAnchor(L["VampwatchFu"], 0.3,0.5,0.8)
	self:RegisterCandyBarGroup("VampwatchFu")
	self:SetCandyBarGroupPoint("VampwatchFu", "TOP", self.anchor, "BOTTOM", 0, 0)	
	self:SetCandyBarGroupGrowth("VampwatchFu", false)
	self:RegisterCandyBar("VampwatchFuSF", 15, bs["Shadowfiend"], "Interface\\Icons\\Spell_Shadow_Shadowfiend", "blue", "yellow", "green", "red")
	self:RegisterCandyBarWithGroup("VampwatchFuSF", "VampwatchFu")
	self:SetCandyBarTexture("VampwatchFuSF", "Interface\\Addons\\FuBar_VampwatchFu\\Texture\\banto")

--	local args = AceLibrary("FuBarPlugin-2.0"):GetAceOptionsDataTable(self)
--	local options = VampwatchFu.menuOptions
--	if not options.args[L["Menu"]] then
--		options.args.menuSpacer = {
--			type = "header",
--			name = " ",
--			order = 900,
--		}
--		options.args[L["Menu"]] = {
--			type = "group",
--			name = L["Menu"],
--			desc = L["Menu options."],
--			args = args,
--			order = 901,
--		}
--	end

	self.OnMenuRequest = VampwatchFu.menuOptions
end

-- GetOverheal Function from SCT by Grayhoof
function VampwatchFu:GetOverheal(target, damage)
	local unit = self:GetTargetUnit(target) or "player";
	local healamt = damage;
	local dmg = damage;
	local overheal = 0;
	local lost = 0;
	if unit then
		local lost = UnitHealthMax(unit)-UnitHealth(unit);
		local overheal = dmg - lost;
		if (overheal > 0) then
			dmg = lost.." {"..overheal.."}";
			healamt = lost;
		end
	end
	return dmg, healamt;
end

--Return the unit if for a given  target from SCT by Grayhoof
function VampwatchFu:GetTargetUnit(target)
	local unit;
	if (target == "player") then
		return "player";
	end
	if (target == UnitName('pet'))then
	  return "pet";
	end
	for i = 1, GetNumRaidMembers(), 1 do
		if ( UnitName("raid" .. i) and UnitName("raid" .. i) == target ) then
			return "raid"..i;
		end
	end
	for i = 1, GetNumPartyMembers(), 1 do
		if ( UnitName("party" .. i) and UnitName("party" .. i) == target ) then
			return "party"..i;
		end
	end
end

function VampwatchFu:OnCombatEvent(event, info)
	self:LevelDebug(2, "OnCombatEvent", event, arg1, info.type)
	-- Parse for the message type.
	local infoType = info.type
	local infoSkill = info.skill
	local infoAmount = info.amount
	local infoSource = info.source
	local infoVictim = info.victim
	if(infoType == 'gain' and infoSource == bs["Shadowfiend"] and infoAmount ~= nil) then
		VampwatchFu.db.char.sfTotal = VampwatchFu.db.char.sfTotal + infoAmount;
		VampwatchFu.db.char.sfTTotal = VampwatchFu.db.char.sfTTotal + infoAmount;
		VampwatchFu.db.char.sfLast = VampwatchFu.db.char.sfLast + infoAmount;
		VampwatchFu.db.char.sfTicks = VampwatchFu.db.char.sfTicks + 1;
		VampwatchFu.db.char.sfAvg = VampwatchFu.db.char.sfTTotal / VampwatchFu.db.char.sfTicks;
		VampwatchFu.db.char.sfAvg = string.sub(VampwatchFu.db.char.sfAvg,1,6);
		if(tonumber(VampwatchFu.db.char.sfHigh) < tonumber(infoAmount)) then
			VampwatchFu.db.char.sfHigh = tonumber(infoAmount);
		end
	elseif(infoType == 'heal' and infoSkill == bs["Vampiric Embrace"] and infoAmount ~= nil and infoSource == ParserLib_SELF) then
		VampwatchFu.db.char.veTicks = VampwatchFu.db.char.veTicks + 1;
		VampwatchFu.db.char.veAvg = VampwatchFu.db.char.veTTotal / VampwatchFu.db.char.veTicks;
		VampwatchFu.db.char.veAvg = string.sub(VampwatchFu.db.char.veAvg,1,6);
		VampwatchFu.db.char.veTTotal = VampwatchFu.db.char.veTTotal + infoAmount;
		if(tonumber(VampwatchFu.db.char.veHigh) < tonumber(infoAmount)) then
			VampwatchFu.db.char.veHigh = tonumber(infoAmount);
		end
		if(VampwatchFu.db.char.filterOverheal == true) then 
			healtot, infoAmount = self:GetOverheal(infoVictim, infoAmount);
		end
		VampwatchFu.db.char.veLast = VampwatchFu.db.char.veLast + infoAmount;
		VampwatchFu.db.char.veTotal = VampwatchFu.db.char.veTotal + infoAmount;
		self:LevelDebug(2, "Overhealing: ", VampwatchFu.db.char.veLast, VampwatchFu.db.char.veTotal)
	elseif(infoType == 'gain' and infoSkill == bs["Vampiric Touch"] and infoAmount ~= nil and infoSource == ParserLib_SELF)then
		VampwatchFu.db.char.vtTotal = VampwatchFu.db.char.vtTotal + infoAmount;
		VampwatchFu.db.char.vtTTotal = VampwatchFu.db.char.vtTTotal + infoAmount;
		VampwatchFu.db.char.vtLast = VampwatchFu.db.char.vtLast + infoAmount;
		VampwatchFu.db.char.vtTicks = VampwatchFu.db.char.vtTicks + 1;
		VampwatchFu.db.char.vtAvg = VampwatchFu.db.char.vtTTotal / VampwatchFu.db.char.vtTicks;
		VampwatchFu.db.char.vtAvg = string.sub(VampwatchFu.db.char.vtAvg,1,6);
		if(tonumber(VampwatchFu.db.char.vtHigh) < tonumber(infoAmount)) then
			VampwatchFu.db.char.vtHigh = tonumber(infoAmount);
		end
	end
	self:UpdateTooltip()
	self:UpdateText()
end

function VampwatchFu:OnEnable()
	if AceDebug then
		self:SetDebugging(VampwatchFu.Debugging)
		self:SetDebugLevel(VampwatchFu.DebugLevel)
	end
end

function VampwatchFu:ToggleAnchor()
	if self.anchor:IsVisible() then
		self.anchor:Hide()
	else
		self.anchor:Show()
	end
end

-- Creates the anchor frames
function VampwatchFu:CreateAnchor(text, cRed, cGreen, cBlue)
	local f = CreateFrame("Button", nil, UIParent)
	f:SetWidth(200)
	f:SetHeight(25)

	f.owner = self

	if VampwatchFu.db.char.barposition.x and VampwatchFu.db.char.barposition.y then
		f:ClearAllPoints()
		f:SetPoint("TOPLEFT", UIParent, "TOPLEFT", VampwatchFu.db.char.barposition.x, VampwatchFu.db.char.barposition.y)
	else
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 50)
	end

	f:SetScript("OnDragStart", function() this:StartMoving() end )
	f:SetScript("OnDragStop",
		function()
			this:StopMovingOrSizing()
			local _, _, _, x, y = this:GetPoint()
			VampwatchFu.db.char.barposition.x = math.floor(x)
			VampwatchFu.db.char.barposition.y = math.floor(y)
        end)

	f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
					edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                    tile = false, tileSize = 16, edgeSize = 16,
					insets = { left = 5, right =5, top = 5, bottom = 5 }})
	f:SetBackdropColor(cRed,cGreen,cBlue,.6)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")

	f.Text = f:CreateFontString(nil, "OVERLAY")
	f.Text:SetFontObject(GameFontNormalSmall)
	f.Text:ClearAllPoints()
	f.Text:SetTextColor(1, 1, 1, 1)
	f.Text:SetWidth(200)
	f.Text:SetHeight(25)
	f.Text:SetPoint("TOPLEFT", f, "TOPLEFT")
	f.Text:SetJustifyH("CENTER")
	f.Text:SetJustifyV("MIDDLE")
	f.Text:SetText(text)

	f:Hide()

	return f
end


function VampwatchFu:OnClick()
	local vw_channel = VampwatchFu.db.char.channel;
	if(not VampwatchFu.db.char.SpamOnClick or VampwatchFu.db.char.SpamOnClick == false) then return end
	if(vw_channel == L["say"]) then
		vw_chat_channel = "SAY"
	elseif(vw_channel == L["party"]) then
		vw_chat_channel = "PARTY"
	elseif(vw_channel == L["raid"]) then
		vw_chat_channel = "RAID"
	elseif(vw_channel == L["guild"]) then
		vw_chat_channel = "GUILD"
	end

	if(VampwatchFu.db.char.useML) then
		VampWatchMessage1 = L[" ## VampwatchFu Stats:"];
		VampWatchMessage2 = L[" ## Vampiric Touch - Last Fight : "] .. VampwatchFu.db.char.vtLast .. " " .. L["mana"] .. ".";
		VampWatchMessage3 = L[" ## Vampiric Touch - All Fights : "] .. VampwatchFu.db.char.vtTotal .. " " .. L["mana"] .. ".";
		VampWatchMessage4 = L[" ## Vampiric Embrace - Last Fight : "] .. VampwatchFu.db.char.veLast .. " " .. L["health"] .. ".";
		VampWatchMessage5 = L[" ## Vampiric Embrace - All Fights : "] .. VampwatchFu.db.char.veTotal .. " " .. L["health"] .. ".";
		SendChatMessage(VampWatchMessage1, vw_chat_channel, nil);
		SendChatMessage(VampWatchMessage2, vw_chat_channel, nil);
		SendChatMessage(VampWatchMessage3, vw_chat_channel, nil);
		SendChatMessage(VampWatchMessage4, vw_chat_channel, nil);
		SendChatMessage(VampWatchMessage5, vw_chat_channel, nil);
	elseif(not VampwatchFu.db.char.useML) then
		SendChatMessage(L["vwFu:: Vampiric Touch Total: "] .. VampwatchFu.db.char.vtTotal .. L[" Vampiric Embrace Total: "] .. VampwatchFu.db.char.veTotal, vw_chat_channel, nil);
	end
end

function VampwatchFu:Confirm(text, onAccept, timeout, whileDead)
	if (self.db.char.useConfirm) then
		if (not timeout) then timeout = 0 end
		if (not whileDead) then whileDead = 1 end
		StaticPopupDialogs["VampwatchFUCONFIRM"].text = text
		StaticPopupDialogs["VampwatchFUCONFIRM"].button1 = L["Yes"]
		StaticPopupDialogs["VampwatchFUCONFIRM"].button2 = L["No"]
		StaticPopupDialogs["VampwatchFUCONFIRM"].timeout = timeout
		StaticPopupDialogs["VampwatchFUCONFIRM"].whileDead = whileDead
		StaticPopupDialogs["VampwatchFUCONFIRM"].OnAccept = onAccept
		StaticPopup_Show("VampwatchFUCONFIRM")
	else
		pcall(onAccept) -- Just execute the damn function
	end
end

function VampwatchFu:VWSpam(stat)
	local vw_spammsg = "";
	local vw_channel = VampwatchFu.db.char.channel;
	if(vw_channel == L["say"]) then
		vw_chat_channel = "SAY"
	elseif(vw_channel == L["party"]) then
		vw_chat_channel = "PARTY"
	elseif(vw_channel == L["raid"]) then
		vw_chat_channel = "RAID"
	elseif(vw_channel == L["guild"]) then
		vw_chat_channel = "GUILD"
	end
	if(stat == "ve_tick") then
		vw_spammsg = L["vwFu: Vampiric Embrace Ticks: "] .. VampwatchFu.db.char.veTicks .. L[" Average Tick: "] .. VampwatchFu.db.char.veAvg .. L[" Highest Tick: "] .. VampwatchFu.db.char.veHigh;
	elseif(stat == "vt_tick") then
		vw_spammsg = L["vwFu: Vampiric Touch Ticks: "] .. VampwatchFu.db.char.vtTicks .. L[" Average Tick: "] .. VampwatchFu.db.char.vtAvg .. L[" Highest Tick: "] .. VampwatchFu.db.char.vtHigh;
	elseif(stat == "ve_total") then
		vw_spammsg = L["vwFu: Vampiric Embrace Total: "] .. VampwatchFu.db.char.veTotal .. " " .. L["health"];
	elseif(stat == "vt_total") then
		vw_spammsg = L["vwFu: Vampiric Touch Total: "] .. VampwatchFu.db.char.vtTotal .. " " .. L["mana"];
	elseif(stat == "vt_last") then
		vw_spammsg = L["vwFu: Vampiric Touch Last: "] .. VampwatchFu.db.char.vtLast .. " " .. L["mana"];
	elseif(stat == "ve_last") then
		vw_spammsg = L["vwFu: Vampiric Embrace Last: "] .. VampwatchFu.db.char.veLast .. " " .. L["health"];
	elseif(stat == "sf_tick") then
		vw_spammsg = L["vwFu: Shadowfiend Ticks: "] .. VampwatchFu.db.char.sfTicks .. L[" Average Tick: "] .. VampwatchFu.db.char.sfAvg .. L[" Highest Tick: "] .. VampwatchFu.db.char.sfHigh;
	elseif(stat == "sf_last") then
		vw_spammsg = L["vwFu: Shadowfiend Last: "] .. VampwatchFu.db.char.sfLast .. " " .. L["mana"];
	elseif(stat == "sf_total") then
		vw_spammsg = L["vwFu: Shadowfiend Total: "] .. VampwatchFu.db.char.sfTotal .. " " .. L["mana"];
	end
	SendChatMessage(vw_spammsg, vw_chat_channel, nil);
end

function VampwatchFu:OnTooltipUpdate()
	local cat = tablet:AddCategory(
			"columns", 2,
			"text", crayon:Purple(bs["Vampiric Touch"]),
			"text2", crayon:Purple(L["Amount"]),
			"child_justify", "LEFT",
			"child_justify2", "LEFT",
			"child_justify3", "RIGHT",
			"child_justify4", "RIGHT",
			"child_textR", 1,
			"child_textG", 1,
			"child_textB", 0,
			"child_text3R", 1,
			"child_text3G", 1,
			"child_text3B", 1,
			"child_text4R", 0.65,
			"child_text4G", 0.65,
			"child_text4B", 0.65
		)
	cat:AddLine(
		'text', L["ticks"], "text2", crayon:Red(VampwatchFu.db.char.vtTicks),
		'func', function() VampwatchFu:VWSpam("vt_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["high"], "text2", crayon:Red(VampwatchFu.db.char.vtHigh),
		'func', function() VampwatchFu:VWSpam("vt_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["avg"], "text2", crayon:Red(VampwatchFu.db.char.vtAvg),
		'func', function() VampwatchFu:VWSpam("vt_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["last"], "text2", crayon:Red(VampwatchFu.db.char.vtLast),
		'func', function() VampwatchFu:VWSpam("vt_last") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["total"], "text2", crayon:Red(VampwatchFu.db.char.vtTotal),
		'func', function() VampwatchFu:VWSpam("vt_total") end,
		'justify', "Left"
	)
	cat:AddLine('text', " ")
	cat:AddLine('text', crayon:Purple(bs["Vampiric Embrace"]), "text2", crayon:Purple(L["Amount"]))
	cat:AddLine(
		'text', L["ticks"], "text2", crayon:Red(VampwatchFu.db.char.veTicks),
		'func', function() VampwatchFu:VWSpam("ve_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["high"], "text2", crayon:Red(VampwatchFu.db.char.veHigh),
		'func', function() VampwatchFu:VWSpam("ve_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["avg"], "text2", crayon:Red(VampwatchFu.db.char.veAvg),
		'func', function() VampwatchFu:VWSpam("ve_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["last"], "text2", crayon:Red(VampwatchFu.db.char.veLast),
		'func', function() VampwatchFu:VWSpam("ve_last") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["total"], "text2", crayon:Red(VampwatchFu.db.char.veTotal),
		'func', function() VampwatchFu:VWSpam("ve_total") end,
		'justify', "Left"
	)
	cat:AddLine('text', " ")
	cat:AddLine('text', crayon:Purple(bs["Shadowfiend"]), "text2", crayon:Purple(L["Amount"]))
	cat:AddLine(
		'text', L["ticks"], "text2", crayon:Red(VampwatchFu.db.char.sfTicks),
		'func', function() VampwatchFu:VWSpam("sf_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["high"], "text2", crayon:Red(VampwatchFu.db.char.sfHigh),
		'func', function() VampwatchFu:VWSpam("sf_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["avg"], "text2", crayon:Red(VampwatchFu.db.char.sfAvg),
		'func', function() VampwatchFu:VWSpam("sf_tick") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["last"], "text2", crayon:Red(VampwatchFu.db.char.sfLast),
		'func', function() VampwatchFu:VWSpam("sf_last") end,
		'justify', "Left"
	)
	cat:AddLine(
		'text', L["total"], "text2", crayon:Red(VampwatchFu.db.char.sfTotal),
		'func', function() VampwatchFu:VWSpam("sf_total") end,
		'justify', "Left"
	)
	tablet:SetHint(L["FuBarHint"])
end